{con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000


obj

 tv : "tv_text"   '}


var

  long a, x, y


{pub go

  tv.start(12)

  a := $90000000
  x := $40000000
  y := $00000000

  show              'show original x,y and angle to rotate by
  cordic(0)         'rotate x,y
  show              'show
  cordic(1)         'convert to polar
  show              'show, should be very close to original
  
  repeat 99         'do a bunch more to see cumulative error
    cordic(0)
    cordic(1)
  show


pri show

  tv.str(string("A "))
  tv.shx(a,8)
  tv.str(string("  X "))
  tv.shx(x,8)
  tv.str(string("  Y "))
  tv.shx(y,8)
  tv.out(13)           '}


pub Cor(_a, _x, _y, mode)
'calls the cordic algorithm with the given parameters
'returns the address of "a"
  a := _a
  x := _x
  y := _y
  cordic(mode)
  result := @a

pub get_a
'gets the results of a cordic run
  result := a

pub get_x
'gets the results of a cordic run
  result := x

pub get_y
'gets the results of a cordic run
  result := y
  

pri cordic(atan2) | negate, i, da, dx, dy

' CORDIC algorithm
'
' if atan2 = 0: x,y are rotated by angle in a
' if atan2 = 1: x,y are converted from cartesian to polar with angle->a, length->x
'
'   - angle range: $00000000-$FFFFFFFF = 0-359.9999999 degrees
'   - hypotenuse of x,y must be within 1_300_000_000 to avoid overflow
'   - algorithm works best if x,y are kept large:
'       example: x=$40000000, y=0, a=angle, cordic(0) performs cos,sin into x,y

  if atan2                      'if atan2 mode, reset a
    a~    
    negate := x < 0             'check quadrant 2 | 3 for either atan2 or rotate mode                        
  else
    negate := (a ^ a << 1) & $80000000
  
  if negate                     'if quadrant 2 | 3, (may be outside 106 convergence range)                                                                 
    a += $80000000              '..add 180 degrees to angle
    -x                          '..negate x
    -y                          '..negate y

  repeat i from 0 to 26         'do CORDIC iterations (27 is optimal for 32-bit values)
    da := corlut[i]
    dx := y ~> i
    dy := x ~> i

    if atan2
      negate := y < 0           'if atan2 mode, drive y towards 0
    else
      negate := a => 0          'if rotate mode, drive a towards 0

    if negate
      -da
      -dx
      -dy

    a += da
    x += dx
    y -= dy

  'remove CORDIC gain by multiplying by ~0.60725293500888        
  i := $4DBA76D4  
  x := (x ** i) << 1 + (x * i) >> 31                           
  y := (y ** i) << 1 + (x * i) >> 31
  

dat

corlut  long $20000000          'CORDIC angle lookup table
        long $12E4051E
        long $09FB385B
        long $051111D4
        long $028B0D43
        long $0145D7E1
        long $00A2F61E
        long $00517C55
        long $0028BE53
        long $00145F2F
        long $000A2F98
        long $000517CC
        long $00028BE6
        long $000145F3
        long $0000A2FA
        long $0000517D
        long $000028BE
        long $0000145F
        long $00000A30
        long $00000518
        long $0000028C
        long $00000146
        long $000000A3
        long $00000051
        long $00000029
        long $00000014
        long $0000000A